import comtypes.client
from comtypes.client import CreateObject, GetActiveObject
import comtypes.gen.AutoCAD as ACAD
import comtypes.gen.AXDBLib as AXDBLib
# import pythoncom
# import logging
import win32com.client                                                  # For Application connection
import pythoncom 
from pyautocad import Autocad,APoint,aDouble,aInt,aShort
import array
import random as rand
import time

import os
import sys
import glob


def vtpt(x, y, z=0):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, (x, y, z))

def vtobj(obj):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_DISPATCH, obj)

def vtFloat(lis):
    """ list converted to floating points"""
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_R8, lis)

def vtint(val):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_I2, val)

def vtvariant(var):
    return win32com.client.VARIANT(pythoncom.VT_ARRAY | pythoncom.VT_VARIANT, var)

try:
        acad = win32com.client.Dispatch("AutoCAD.Application")  

except:
        print ("AutoCAD isn't running!")

doc = acad.ActiveDocument #Document Object




model = doc.ModelSpace


layout1 = doc.Layouts[0]
print(layout1.name)

layout2 = doc.Layouts('Layout2')
print(layout2.name)

acad.Visible = False
acad.Visible = True
print(acad.FullName)



print(doc.Name)



print(doc.Path)


layNew = doc.Layers.Add('Wafalo')


layNew.color = rand.randrange(start=1, stop=255)


# Cria Layout
layoutNew = doc.Layouts.Add('Teste')


# Apaga Layout
layoutNew.Delete()


# Purge
doc.PurgeAll()


# Audit
doc.AuditInfo(FixErr=True)

doc.SetVariable('PEDITACCEPT', 1)

line1 = model.AddLine(vtpt(120, 250, 0), vtpt(120 + 15, 250 - 3, 0))


line2 = model.AddLine(StartPoint=vtpt(180, 280, 0),EndPoint=vtpt( 175, 270, 0))


acad.ZoomExtents()


line1.color = 1
line2.color = 3



line1.Move(vtpt (0, 0, 0), vtpt (50, 25, 0))



acad.ZoomExtents()



line1.Delta


line1.StartPoint



line1.EndPoint



line1.Layer



line1.GetBoundingBox()



line1.Linetype



line1.Length



# acExtendNone
# acExtendBoth
# acExtents
# acExtendOtherEntity
# acExtendThisEntity

line1.IntersectWith(line2, 0)
#LwPolyline



CoordList = []
for dist in range(0, 1020, 20):
    CoordList = CoordList + [dist, rand.randrange(start=200, stop=240)]
    pass
CoordList = array.array('d', CoordList)


#CoordList = array.array('d', [200,220 , 220,225 , 240,230 , 260,219])
#lwPoly = model.AddLightWeightPolyline(VerticesList=CoordList)



acad.ZoomExtents()





try:
    doc.SelectionSets.Item("SS1").Delete()
except:
    pass
slt = doc.SelectionSets.Add("SS1")
FilterData = vtvariant(["<or", "circle", "lwpolyline", "hatch", "text", "line", "or>"])
FilterType = vtint([-4, 0, 0, 0, 0, 0, -4])
slt.Select(1, vtpt(0, 1000), vtpt(594, 1940), FilterType, FilterData)
for obj in slt:
    doc.ObjectIdToObject(obj.ObjectID).copy().Move(vtpt(0, 1000), vtpt(0, 0))
time.sleep(1)

try:
    doc.SelectionSets.Item("SS1").Delete()
except:
    pass
slt = doc.SelectionSets.Add("SS1")
FilterData = vtvariant(["<or", "circle", "lwpolyline", "hatch", "text", "line", "or>"])
FilterType = vtint([-4, 0, 0, 0, 0, 0, -4])
slt.Select(1, vtpt(0, 0), vtpt(594, 420), FilterType, FilterData)#lwPoly.Erase()
print ('Selection.count=' , slt.count)
#============================================ O K =============================
try:
    doc.SelectionSets.Item("SS1").Delete()
except:
    a="Delete selection failed"
    
model.addCircle(vtpt(20,20),10)

ssget1 = doc.SelectionSets.Add("SS1")

    
SELECT_ALL = int(5) # 5=variable de autocad para selecionar todo

    #selecciona entidad circulo, Codigo dxf=0, Filterdata="Circle"
#selecciona radio del circulo, Codigo dxf=40, Filerdata=10, Todos los cirulos con radio =10
    #selecciona layer, Codigo dxf=8, Filterdata="uno", y que estan en el layer uno
    
valor=vtpt(0,0,0) #Necesario para parte del filtro
FilterType=vtint((0,40,8))
FilterData=vtvariant(('Circle',10,'0'))

    #selecionar de acuerdo al criterio de filtro
ssget1.Select(SELECT_ALL,valor,valor,FilterType,FilterData)

    #Contar entidades
icount = ssget1.Count

print(icount)

    #Moverl al layer movido
for entity in ssget1:
        entity.Layer="0"
        entity.color  =1
#============================================= O  K ==============================